<?php
/*
CMSimple kissgallery plugin version 0.1
History:
- 0.2 First public release
		* Code cleanup
		* Error checking
- 0.1 First internal release
*/
if (!defined('KISSLIBV')) require dirname(__FILE__)."/kiss.php";

function saveThumb($arr_img, $filename, $dst_w, $dst_h, $qty){
	$width = $arr_img["w"];
	$height = $arr_img["h"];
	$proportion_X = $width / $dst_w;
	$proportion_Y = $height / $dst_h;
	if($proportion_X > $proportion_Y ){
		$proportion = $proportion_Y;
	} else {
		$proportion = $proportion_X ;
	}
	$target['width'] = $dst_w * $proportion;
	$target['height'] = $dst_h * $proportion;
	$original['diagonal_center'] =round(sqrt(($width*$width)+($height*$height))/2);
	$target['diagonal_center'] =round(sqrt(($target['width']*$target['width'])+($target['height']*$target['height']))/2);
	$crop = round($original['diagonal_center'] - $target['diagonal_center']);
	if($proportion_X < $proportion_Y ){
		$target['x'] = 0;
		$target['y'] = round((($height/2)*$crop)/$target['diagonal_center']);
	} else {
		$target['x'] =  round((($width/2)*$crop)/$target['diagonal_center']);
		$target['y'] = 0;
	}
	$new = ImageCreateTrueColor ($dst_w,$dst_h);
	imagecopyresampled ($new, $arr_img["img"],  0, 0, $target['x'],$target['y'], $dst_w, $dst_h, $target['width'], $target['height']);
	$white = imagecolorallocate($new, 255, 255, 255);
	imagefill($new, 0, 0, $white);
	imagejpeg($new,$filename,$qty);
}

function getSizes($src_w, $src_h, $dst_w, $dst_h ) {
   $mlt_w = $dst_w / $src_w;
   $mlt_h = $dst_h / $src_h;
   $mlt = $mlt_w < $mlt_h ? $mlt_w:$mlt_h;
   if ($dst_w == "*") $mlt = $mlt_h;
   if ($dst_h == "*") $mlt = $mlt_w;
   if ($dst_w == "*" && $dst_h == "*") $mlt=1;
   #### Calculate new dimensions
   $img_new_w =  round($src_w * $mlt);
   $img_new_h =  round($src_h * $mlt);
   return array("w" => $img_new_w, "h" => $img_new_h, "mlt_w"=>$mlt_w, "mlt_h"=>$mlt_h,  "mlt"=>$mlt);
}  

function imgGetResized($img_original,$img_w,$img_h,$img_new_w,$img_new_h) {
   $img_resized = imagecreatetruecolor($img_new_w,$img_new_h);
   imagecopyresampled($img_resized, $img_original, 0, 0, 0, 0,$img_new_w, $img_new_h, $img_w, $img_h);
   return $img_resized;
} 

function saveImage($arr_img,$filename,$w,$h,$qty) {
  if ($arr_img["w"] > $w || $arr_img["h"] > $h) {
    $wh = getSizes($arr_img["w"], $arr_img["h"], $w, $h);
    $img_res = imgGetResized($arr_img["img"],$arr_img["w"],$arr_img["h"],$wh["w"],$wh["h"]);
    ImageJPEG($img_res,$filename,$qty);
  } else {
    ImageJPEG($arr_img["img"],$filename,$qty);
  }
}

function imageFromUpload($uploaded_file){
   $img_sz =  getimagesize($uploaded_file );     
   switch($img_sz[2] ){
       case 1:
           $img_type = "GIF";
           $img = ImageCreateFromGif($uploaded_file);
       break;
       case 2:
           $img = ImageCreateFromJpeg($uploaded_file);
           $img_type = "JPG";
       break;
       case 3:
           $img = ImageCreateFromPng($uploaded_file);
           $img_type = "PNG";
       break;
       case 4:
           $img = ImageCreateFromSwf($uploaded_file);
           $img_type = "SWF";
       break;
       default: return array(false);
   }
   return array("img"=>$img, "w"=>$img_sz[0], "h"=>$img_sz[1], "type"=>$img_sz[2], "html"=>$img_sz[3]);
} 

function getImage($img,$id,$filepath) {
	global $plugin_cf;
    $arr_img = imageFromUpload($img);
	if ($arr_img['img']) {
		saveImage($arr_img,$filepath.'/'.$id.'.jpg',$plugin_cf['kissgallery']['max_size_photo'],$plugin_cf['kissgallery']['max_size_photo'],$plugin_cf['kissgallery']['jpeg_quality']);
		saveImage($arr_img,$filepath.'/'.$id.'s.jpg',$plugin_cf['kissgallery']['max_size_small'],$plugin_cf['kissgallery']['max_size_small'],$plugin_cf['kissgallery']['jpeg_quality']);
		saveThumb($arr_img,$filepath.'/'.$id.'t.jpg',$plugin_cf['kissgallery']['thumb_width'],$plugin_cf['kissgallery']['thumb_height'],$plugin_cf['kissgallery']['jpeg_quality']);
		imagedestroy($arr_img["img"]);
		return true;
	} else {
		return false;
	}
} 

if(isset($kissgallery)) {
	$admin=kissGetVar('admin');
	$action=kissGetVar('action');
	$plugin=basename(dirname(__FILE__),"/");
	$fngroup=dirname(__FILE__).'/data/album.txt';
	$fnfile=dirname(__FILE__).'/data/photo.txt';
    $imgpath=$pth['folder']['plugins'].$plugin."/images";
    $filepath=$pth['folder']['plugins'].$plugin."/photos";
		
	kissWriteAccess($fngroup);
	kissWriteAccess($fnfile);
	kissWriteAccess($pth['folder']['plugins']."$plugin/config/config.php");
	kissWriteAccess($pth['folder']['plugins']."$plugin/css/stylesheet.css");
	kissWriteAccess($pth['folder']['plugins']."$plugin/languages/$sl.php");
	kissWriteAccess($filepath);
		
	$o.=print_plugin_admin('on');
	if($admin<>'plugin_main'){$o.=plugin_admin_common($action,$admin,$plugin);}
	if($admin=='')$o.='<br /><hr size="1" />
					<font size = 3><strong>kissGallery - Plugin</strong></font>
					<hr size="1" />
					Version: v0.2 - alpha<br />
					Library: v'.KISSLIBV.'<br />
					Released: 17.01.2008<br />
					Developed by: Claus H&oslash;jberg (alias Softly)<br />
					Email:<a href="mailto:cmsimple@softly.dk">&nbsp;cmsimple@softly.dk</a><br />
					Website:<a target="_blank" href="http://softly.dk/?CMSimple">&nbsp;softly.dk?CMSimple</a><br />
					<br />kissGallery is powered by <a target="_blank" href="http://mootools.net/">MooTools</a> and <a target="_blank" href="http://www.digitalia.be/software/slimbox">SlimBox</a><br />
					<br />Support for external image browser in <a target="_blank" href="http://tinymce.moxiecode.com/">TinyMce</a>  <br />
					<br />This is the first public release of the gallery - an alpha release
					<hr size="1" />';

	if ($admin == 'plugin_main') {
		$id=kissGetVar('id');
		$gid=kissGetVar('gid');
		$groups=kissRFile($fngroup);
		if ($action=='save_group') {
			$order=kissGetNumber(kissGetVar('order'));
			$name=strtr(kissGetVar('name'),"#","_");
			$desc=strtr(kissGetVar('desc'),"#","_");
			if ($gid==0) {
				$gid=kissNextID($groups);
				$groups[]=array($gid,$order,$name,$desc);
			} else {
				foreach ($groups as $num => $rec) {
					if ($rec[0]==$gid) {
						$groups[$num][1]=$order;
						$groups[$num][2]=$name;
						$groups[$num][3]=$desc;
					}
				}
			}
			kissWFile($fngroup,$groups);
			$groups=kissRFile($fngroup);
		}
		if ($action=='edit_group') {
			foreach ($groups as $num => $rec) {
				if ($rec[0]==$gid) {
					$order=$rec[1];
					$name=$rec[2];
					$desc=$rec[3];
				}
			}
			$o .='<form method="post" action="'.$sn.'?'.amp().$plugin.'">';
			$o .="<fieldset><legend>".$plugin_tx['kissgallery']['edit_record']."</legend>";
			$o .="<table>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['group_id']."</label></td><td>$gid</td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['order_id']."</label></td><td><input type='text' class='text' size='64' value=\"$order\" name='order' width='64'></td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['group']."</label></td><td><input type='text' class='text' size='64' value=\"$name\" name='name' width='64'></td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['description']."</label></td><td><input type='text' class='text' size='64' value=\"$desc\" name='desc' width='64'></td></tr>";
			$o .="<tr><td><input type='submit' value=".ucfirst(strtolower($tx['action']['save']))." name='save' id='save'></td><td></td></tr>";
			$o .="</table>";
			$o .="</fieldset>";
			$o .="<input type='hidden' value='$admin' name='admin'>";
			$o .="<input type='hidden' value='save_group' name='action'>";
			$o .="<input type='hidden' value=\"$gid\" name='gid'>";
			$o .="</form>";
		}

		$files=kissRFile($fnfile);
		if ($action=='save_file') {
			$order=kissGetNumber(kissGetVar('order'));
			$file_name=kissGetVar('file_name');
			$desc=strtr(kissGetVar('desc'),"#","_");
            $desc_en=strtr(kissGetVar('desc_en'),"#","_");               
            $desc_it=strtr(kissGetVar('desc_it'),"#","_");               
			if ($id==0) {
				$file_name = strtolower($GLOBALS['HTTP_POST_FILES']['file_name']['name']);
				if ($desc=='') $desc=$file_name;
				if ($order=='') $order=time();
				$file_size = $GLOBALS['HTTP_POST_FILES']['file_name']['size'];
				$file_tmp = $GLOBALS['HTTP_POST_FILES']['file_name']['tmp_name'];
				$file_type = $GLOBALS['HTTP_POST_FILES']['file_name']['type'];
				$ext='/\\'.str_replace(',','|\\',$plugin_cf['kissgallery']['file_extension']).'/i';
				if (!(preg_match($ext, $file_name))) $e.='<li>'.$tx['error']['wrongext'].' '.$file_name.'</li>';
				if ($file_size > $plugin_cf['kissgallery']['max_filesize']) $e .= '<li>'.$file_name.' '.$tx['error']['tolarge'].' '.$plugin_cf['kissgallery']['max_filesize'].' '.$tx['files']['bytes'].'</li>';
				if (!$e) {
					$id=kissNextID($files);
					if (getImage($file_tmp,$id,$filepath)) {
						$o .= '<p>'.ucfirst($tx['filetype']['file']).' '.$file_name.' '.$tx['result']['uploaded'].'</p>';
						$file_datetime=time();
						$files[]=array($id,$order,$gid,$file_name,$file_datetime,$file_type,$desc);
					}
					else e('cntsave', 'file', $file_name);
				}
			} else {
				foreach ($files as $num => $rec) {
					if ($rec[0]==$id) {
						$files[$num][1]=$order;
						$files[$num][2]=$gid;
						$files[$num][6]=$desc;
                        $files[$num][7]=$desc_en;                                
                        $files[$num][8]=$desc_it;        
                    }
				}
			}
			kissWFile($fnfile,$files);
  			$files=kissRFile($fnfile);
		}
		if ($action=='delete_file') {
			$tarr=array();
			foreach ($files as $num => $rec) {
				if ($rec[0]!=$id) {
					$tarr[]=$rec;
					$rrr=unlink("$filepath/$id.jpg");
					$rrr=unlink("$filepath/$id"."s.jpg");
					$rrr=unlink("$filepath/$id"."t.jpg");
				}
			}
			kissWFile($fnfile,$tarr);
  			$files=kissRFile($fnfile);
		}
		if ($action=='edit_file' || kissGetVar('more')) {
			if (kissGetVar('more')) $id=0;
			$order='';
			$file_name='';
			$file_datetime=0;
			$desc='';
			foreach ($files as $num => $rec) {
				if ($rec[0]==$id) {
					$order=$rec[1];
					$gid=$rec[2];
					$file_name=$rec[3];
					$file_datetime=date($plugin_cf['kissgallery']['datetime_format'],$rec[4]);
					$desc=$rec[6];
                    $desc_en=$rec[7];  
                    $desc_it=$rec[8];  
				}
			}
			$o .='<form method="post" action="'.$sn.'?'.amp().$plugin.'" enctype="multipart/form-data">';
			$o .="<fieldset><legend>".$plugin_tx['kissgallery']['edit_record']."</legend>";
			$o .="<table>";
			if (!$id==0) $o .="<tr><td><label></label></td><td><img src=\"$filepath/$id"."t.jpg\" border=\"0\"></td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['file_id']."</label></td><td>$id</td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['file_name']."</label></td><td>";
			if ($id==0) $o .="<input type='file' class='text' size='40' value=\" \" name='file_name' width='64'></td></tr>";
			else $o .="$file_name</td></tr>";
			if ($id>0) $o .="<tr><td><label>".$plugin_tx['kissgallery']['file_datetime']."</label></td><td>$file_datetime</td></tr>";
			$o .="<tr><td><label>".$plugin_tx['kissgallery']['order_id']."</label></td><td><input type='text' class='text' size='64' value=\"$order\" name='order' width='64'></td></tr>";
            $o .="<tr><td><label>".$plugin_tx['kissgallery']['description']."-de</label></td><td><input type='text' class='text' size='64' value=\"$desc\" name='desc' width='64'></td></tr>";
            $o .="<tr><td><label>".$plugin_tx['kissgallery']['description']."-en</label></td><td><input type='text' class='text' size='64' value=\"$desc_en\" name='desc_en' width='64'></td></tr>";
            $o .="<tr><td><label>".$plugin_tx['kissgallery']['description']."-it</label></td><td><input type='text' class='text' size='64' value=\"$desc_it\" name='desc_it' width='64'></td></tr>";

			$o .="<tr><td><label>".$plugin_tx['kissgallery']['group_id']."</label></td><td><select name='gid'>";
			foreach ($groups as $num => $rec) {
				$o .="<option value=\"$rec[0]\"";
				if ($rec[0]==$gid) {
					$o .=' SELECTED';
				}
				$o .= ">$rec[2]</option>";
			}
			$o .="</select></td></tr>";
			if ($id==0)	$o .="<tr><td></td><td><input type='checkbox' class='text' name='more' checked>&nbsp;".$plugin_tx['kissgallery']['more_uploads']."</td></tr>";
			$o .="<tr><td><input type='submit' value=".ucfirst(strtolower($tx['action']['save']))." name='save' id='save'></td><td></td></tr>";
			$o .="</table>";
			$o .="</fieldset>";
			$o .="<input type='hidden' value='$admin' name='admin'>";
			$o .="<input type='hidden' value='save_file' name='action'>";
			$o .="<input type='hidden' value=\"$id\" name='id'>";
			$o .="</form>";
		}
		if ($action!='edit_file' && $action!='edit_group' && !kissGetVar('more')) {
			$o.='<br><table class="edit" width="100%" cellpadding="1" cellspacing="0" border="1">';
			$o.="<tr><td colspan=\"4\"><form>".$plugin_tx['kissgallery']['group'].": <select name=\"gid\" onchange=\"location.href=this.options[this.selectedIndex].value\">";
			if ($gid=='') $gid=$groups[0][0];
			foreach ($groups as $num => $rec) {
				$o .="<option value=\"$sn?&$plugin&admin=$admin&action=list_files&gid=$rec[0]\"".(($rec[0] == $gid)?' selected="selected"':'').">$rec[2] [id:$rec[0]]</option>";
			}
			$o.="</select>";
			if (sizeof($groups)>0) $o.="&nbsp;&nbsp;<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=edit_group&gid=$gid\"><img align=\"absbottom\" src=\"$imgpath/edit.gif\"></a>";
			$o.="&nbsp;&nbsp;<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=edit_group&gid=0\"><img align=\"absbottom\" src=\"$imgpath/add.gif\"></a>";
			$o.="</form></td></tr>";
			if (sizeof($groups)>0) {
				$o.='<tr><td  width="45px">'."<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=edit_file&id=0&gid=$gid\"><img src=\"$imgpath/add.gif\"></a>".'</td><td width="10%">'.$plugin_tx['kissgallery']['file_id'].'</td><td>'.$plugin_tx['kissgallery']['name'].'</td><td>'.$plugin_tx['kissgallery']['description'].'</td></tr>';
				foreach ($files as $num => $rec) {
					if ($gid==$rec[2]) {
                            $desc=$rec[6];
                            if ($sl=='en' && isset($rec[7])) $desc=$rec[7];    // WB+
                            if ($sl=='it' && isset($rec[8])) $desc=$rec[8];                                    
						    $o.='<tr><td>'."<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=edit_file&id=$rec[0]\"><img src=\"$imgpath/edit.gif\"></a>"
       			            ."&nbsp;&nbsp;<a href=\"".$sn.'?'.amp().$plugin."&admin=$admin&action=delete_file&id=$rec[0]&gid=$gid\"><img src=\"$imgpath/delete.gif\"></a>".'</td>'					
						    .'<td align="right">'.$rec[0].'</td><td>'.$rec[3].'</td><td>'.$desc.'</td></tr>';
					}
				}
			}
			$o.='</table>';
		}
	}
}
?>